const Main = imports.ui.main;

let delay = 200;
let timeout = null;

function onOverviewActivated() {
    Main.overview.dash.hide();
}

function onOverviewDeactivated() {
    timeout = setTimeout(() => {
        Main.overview.dash.show();
    }, delay);
}

class DockExtension {
    enable() { 
        this.showingSignalId = Main.overview.connect('showing', onOverviewActivated);
        this.hiddenSignalId = Main.overview.connect('hiding', onOverviewDeactivated);
    }
    disable() {
        Main.overview.disconnect(this.showingSignalId);
        Main.overview.disconnect(this.hiddenSignalId);
        if(timeout){
            clearInterval(timeout);
        }
    }
}

function init() {
    return new DockExtension(); 
}
